/****************************************************************************************
   Temperatur Logger - Software for logging temperature data with the DS18B20 and ESP32
   Written by Sebastian Hinz, https://www.diy-temperature-logger.com
   Licensed under GPLv3. See LICENSE for details.
****************************************************************************************/
#ifndef _HANDLE_SD_H_
#define _HANDLE_SD_H_

#include <arduino.h>
#include "FS.h"
#include "SD.h"
#include "SPI.h"

class handleSD
{
public:
  handleSD();
  static handleSD& GetInstance();
 
  void setup();
  void writeToSD();
  String listDir(const char * dirname, uint8_t levels);
  unsigned long getSDTime();
  bool deleteFile(char* path);

  String buildPath(int year, int month, int day, String sensorId);

  boolean takeSaveFilesAccess(TickType_t xTicksToWait);
  void releaseSaveFileAccess();
  void writeBootTime();
  

private:
  unsigned long         m_NextLoop;
  int                   m_lastDay;
  SemaphoreHandle_t     m_xRWSemaphore;
  unsigned long         m_fileTimes[2];
};

#endif
