/****************************************************************************************
   Temperatur Logger - Software for logging temperature data with the DS18B20 and ESP32
   Written by Sebastian Hinz, https://www.diy-temperature-logger.com
   Licensed under GPLv3. See LICENSE for details.
****************************************************************************************/
// OLED pins to ESP32 GPIOs via this connection:
// OLED_SDA -- GPIO5
// OLED_SCL -- GPIO4
// OLED_RST -- GPIO16

// DS18B20 - GPIO25 - Data

// SD - GPIO12 - SCL
// SD - GPIO15 - MISO 
// SD - GPIO13 - MOSI
// SD - GPIO14 - CS


//////////////////////////////////////////////////////////////////////
void setup_1306();
void loop_1306();
void setup_sd();
void run_18b20(void * pvParameters);

//////////////////////////////////////////////////////////////////////
void setup()
{
  Serial.begin(115200);
  Serial.println();
  Serial.println();

  
  setup_1306();
  setup_sd();

  // start sensor detection 
  xTaskCreatePinnedToCore(
    run_18b20,       // Function to implement the task 
    "tempTask",                     // Name of the task 
    4000,                           // Stack size in words 
    NULL,                           // Task input parameter 
    7,                              // Priority of the task 
    NULL,                           // Task handle. 
    1);                             // Core where the task should run 
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  loop_1306();
}

//////////////////////////////////////////////////////////////////////


