/****************************************************************************************
   Temperatur Logger - Software for logging temperature data with the DS18B20 and ESP32
   Written by Sebastian Hinz, https://www.diy-temperature-logger.com
   Licensed under GPLv3. See LICENSE for details.
****************************************************************************************/
/*
 * Connect the SD card to the following pins:
 *
// SD - GPIO12 - SCL
// SD - GPIO15 - MISO 
// SD - GPIO13 - MOSI
// SD - GPIO14 - CS
 */

#include <arduino.h>
#include "FS.h"
#include "SD.h"
#include "SPI.h"

extern char *pSD;
 
//////////////////////////////////////////////////////////////////////
void setup_sd()
{
  //SPI.begin(18,19,23); if(!SD.begin(5)
  //  void begin(int8_t sck=-1, int8_t miso=-1, int8_t mosi=-1, int8_t ss=-1);
  SPI.begin(12, 15, 13);   
  
  int i = 0;
  for(i = 0; i < 10; i++)
  {
    if(SD.begin(14, SPI)) {
      break;
    }
    Serial.printf("Card Reader Failed %d\n", i);
   // display1306::GetInstance().addMessage(String("Card Mount Failed ") + String(i), MESSAGE_SD_CARD_MOUNT_FAILED, DISPLAY_TIME_INFINITE);
  
    delay(150);
  }
  if (i==10)
  {
    pSD = "Card Reader Failed";
    return;
  }
  
  uint8_t cardType = SD.cardType();
  
  if(cardType == CARD_NONE)
  {
      pSD = "No SD card found";
      Serial.println("No SD card attached");
     // display1306::GetInstance().addMessage(String("No SD card attached"), MESSAGE_NO_SD_CARD_ATTACHED, DISPLAY_TIME_INFINITE);
  
      return;
  }


  File file = SD.open("/Test.txt", FILE_WRITE);
  if(!file)
  {
      Serial.println("Failed to open file for appending"); 
      pSD = "Can not write file.";
      return;
  }
  
  if(file.println("Test Content"))
  {
   //   Serial.println("Message appended");
  } 
  else 
  {
      pSD = "Can not write to file.";
      Serial.println("Append failed");
      return;
  }
  file.close();

  file = SD.open("/Test.txt", FILE_READ);
  if(!file)
  {
      pSD = "Can not read file.";
      return;
  }
  file.close();

  pSD = "SD reader and card OK";
}


